/*
*     Hlavickovy subor pre usb_com.c
*/

#ifndef USB_COM_H
#define USB_COM_H

// Definicie endpointov
// prijem udajov - endpoint 1
#define AT91C_EP_OUT 1
// velkost endpointu - 64 B
#define AT91C_EP_OUT_SIZE 0x40
// vysielanie udajov - endpoint 2
#define AT91C_EP_IN  2
// velkost endpointu - 64 B
#define AT91C_EP_IN_SIZE 0x40

// definicia CDC struktury
typedef struct _AT91S_CDC
{
	// privatne premenne
	AT91PS_UDP pUdp;
	unsigned char currentConfiguration;
	unsigned char currentConnection;
	unsigned int  currentRcvBank;
	// verejne metody
	unsigned char (*IsConfigured)(struct _AT91S_CDC *pCdc);
	unsigned int  (*Write) (struct _AT91S_CDC *pCdc, const char *pData, unsigned int length);
	unsigned int  (*Read)  (struct _AT91S_CDC *pCdc, char *pData, unsigned int length);
	unsigned char (*IsData)(struct _AT91S_CDC *pCdc);
} AT91S_CDC, *AT91PS_CDC;

// externa funkcia

AT91PS_CDC AT91F_CDC_Open(AT91PS_CDC pCdc, AT91PS_UDP pUdp);

#endif // USB_COM_H
